package yrpg.gmscm.rc.rcd.agreement.form;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.form.CloseCallBack;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.plugin.AbstractFormPlugin;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * @author zhangjiawei
 * @date 2024/4/29 15:19
 */
public class AgmApplyStopChangeFormPlugin extends AbstractFormPlugin {


    @Override
    public void afterDoOperation(AfterDoOperationEventArgs args) {
        if ("stop_agm_from".equals(args.getOperateKey())) {
            String billno = (String) this.getModel().getValue("billno");
            Boolean rmOnterminate = (Boolean) this.getModel().getValue("rm_onterminate");
            if (rmOnterminate) {
                this.getView().showTipNotification("已终止，请勿重复终止！");
            }else {
                stopAgm(billno);
            }

        }
    }
    @Override
    public void closedCallBack(ClosedCallBackEvent closedCallBackEvent) {
        String actionId = closedCallBackEvent.getActionId();
        if ("rm_terminate_pop".equals(actionId)) {
            Object returnData = closedCallBackEvent.getReturnData();
            if (returnData instanceof Map){
                //从终止单据里获取终止时间
                Map<String, Object> map = (Map<String, Object>) returnData;
                Date stopDate = (Date) map.get("rm_terminate_date");
                //终止信息赋值
                this.getModel().setValue("rm_terminate_tag",true);
                this.getModel().setValue("rm_terminate_time",stopDate);
                //判断结束日期在终止日期之前 不改变，开始日期在终止日期之后 结束日期=开始日期
                for (DynamicObject rmRcPolicyrecordDtl : this.getModel().getEntryEntity("rm_rc_policyrecord_dtl")) {
                    DynamicObjectCollection rmRcPolicyDtlDtl = rmRcPolicyrecordDtl.getDynamicObjectCollection("rm_rc_policy_dtl_dtl");
                    for (DynamicObject row : rmRcPolicyDtlDtl) {
                        Date begin = row.getDate("rm_date_begin");
                        Date end = row.getDate("rm_date_end");
                        if (stopDate.before(begin)) {
                            row.set("rm_date_end",begin);
                            continue;
                        }
                        if (end.before(stopDate)) {
                            continue;
                        }
                        row.set("rm_date_end",stopDate);
                    }
                }
                this.getModel().setValue("rm_onterminate",true);
                this.getView().updateView();
            }

        }
    }

    /**
     * 打开终止界面
     */
    private void stopAgm(String billno){

        this.getModel().setValue("rm_apply_type","C");
        this.getModel().setValue("rm_agm_change_main",billno);

        Map<String ,Object> map = new HashMap<>();
        map.put("number",billno);

        FormShowParameter showParameter = new FormShowParameter();
        showParameter.setFormId("rm_terminate_pop");
        showParameter.getOpenStyle().setShowType(ShowType.Modal);
        showParameter.setCustomParams(map);
        showParameter.setCloseCallBack(new CloseCallBack(this, "rm_terminate_pop"));
        this.getView().showForm(showParameter);
    }
}
