package yrpg.gmscm.rc.rcd.agreement.operator;


import com.alibaba.fastjson.JSONArray;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.validate.AbstractValidator;
import yrpg.gmscm.rc.rcd.tools.GetFieldsHelper;
import yrpg.gmscm.rc.rcd.tools.RmRcConfigHelper;

import java.util.List;
import java.util.Map;

/**
 * @author zhangjiawei
 * &#064;date  2024/4/26 9:43
 */
public class AgmApplyAgmTypeSubmitOpPlugin extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        List<String> fieldKeys = e.getFieldKeys();
        List<String> costApplyFields = GetFieldsHelper.getAllFieldsList("rm_rcd_settle_ask");
        fieldKeys.addAll(costApplyFields);
        fieldKeys.add("rm_rc_policyrecord_dtl.seq");
    }
    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        e.addValidator(new validation()); //注册校验器
        validators = e.getValidators();
    }

    public List<AbstractValidator> validators = null;

    public static class validation extends AbstractValidator {

        @Override
        /*
         * 根据配置项 校验单据内 进货上游 是否为空
         */
        public void validate() {
            Map<Object, JSONArray> allConfig = RmRcConfigHelper.getAllConfig(this.dataEntities, "rm_agm_types.fbasedataid.id");
            for (ExtendedDataEntity dataEntity : this.dataEntities) {
                DynamicObject billData = dataEntity.getDataEntity();
                DynamicObject rmAgmType = billData.getDynamicObject("rm_agm_type");
                DynamicObject accorg = billData.getDynamicObject("rm_accorg");
                if (rmAgmType!=null) {
                    Object agmTypeId = rmAgmType.getPkValue();
                    JSONArray jsonArray = allConfig.get(accorg.getPkValue());
                    if (jsonArray.contains(agmTypeId)) {
                        //协议过滤进货上游
                        DynamicObjectCollection entry = billData.getDynamicObjectCollection("rm_pur_upstream_entry");
                        if (entry.isEmpty()) {
                            this.addErrorMessage(dataEntity,"该协议类型下进货上游不允许为空！");
                        }
                    }
                }
            }
        }



    }

}
