package yrpg.gmscm.rc.rcd.agreement.operator;

import cn.romens.cloud.xdepot.entity.base.RMEntityHelper;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.EntityType;
import kd.bos.entity.MainEntityType;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import yrpg.gmscm.rc.rcd.enumerate.AgmApplyTypeEnum;

import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @author zhangjiawei
 * @date 2024/4/28 11:01
 */
public class AgmApplyAuditOpPlugin extends AbstractOperationServicePlugIn {
    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        List<Object> successPkIds = getOperationResult().getSuccessPkIds();
        DynamicObject[] rmRcAgreementApplies = RMEntityHelper.load("rm_rc_agreement_apply", successPkIds.toArray());
        for (DynamicObject rmRcAgreementApply : rmRcAgreementApplies) {
            //协议申请
            String rmApplyType = rmRcAgreementApply.getString("rm_apply_type");
            if (AgmApplyTypeEnum.NEW.getKey().equals(rmApplyType)) {
                newAgreement(rmRcAgreementApply);
            }else if(AgmApplyTypeEnum.CHANGE.getKey().equals(rmApplyType)){
                changeAgreement(rmRcAgreementApply);
            }else if(AgmApplyTypeEnum.STOP.getKey().equals(rmApplyType)){
                changeAgreement(rmRcAgreementApply);
            }
        }
    }

    /**
     * 新增协议时赋值
     * @param rmRcAgreementApply 协议申请
     */
    private static void newAgreement(DynamicObject rmRcAgreementApply) {
        //协议
        DynamicObject newAgreement = BusinessDataServiceHelper.newDynamicObject("rm_rc_agreement");
        //单据头
        MainEntityType billType = RMEntityHelper.getEntityType("rm_rc_agreement_apply");
        Map<String, EntityType> allEntities = billType.getAllEntities();
        EntityType entityType = allEntities.get("rm_rc_agreement_apply");
        Set<String> rmRcAgreementApplySet = entityType.getFields().keySet();
        for (String field : rmRcAgreementApplySet) {
            newAgreement.set(field, rmRcAgreementApply.get(field));
        }
        //物料明细
        DynamicObjectCollection rmRcPolicyrecordDtl = rmRcAgreementApply.getDynamicObjectCollection("rm_rc_policyrecord_dtl");
        DynamicObjectCollection newRcPolicyrecordDtl = newAgreement.getDynamicObjectCollection("rm_rc_policyrecord_dtl");
        EntityType policyrecordDtl = allEntities.get("rm_rc_policyrecord_dtl");
        Set<String> policyrecordDtlSet = policyrecordDtl.getFields().keySet();
        //子单据体
        EntityType rcPolicyDtlDtl = allEntities.get("rm_rc_policy_dtl_dtl");
        Set<String> rcPolicyDtlDtlSet = rcPolicyDtlDtl.getFields().keySet();
        for (DynamicObject row : rmRcPolicyrecordDtl) {
            DynamicObjectCollection policyDtlDtl = row.getDynamicObjectCollection("rm_rc_policy_dtl_dtl");
            DynamicObject rowNew = newRcPolicyrecordDtl.addNew();
            for (String field : policyrecordDtlSet) {
                rowNew.set(field,row.get(field));
            }
            for (DynamicObject policyDtlDtlRow : policyDtlDtl) {
                DynamicObjectCollection newPolicyDtlDtl = rowNew.getDynamicObjectCollection("rm_rc_policy_dtl_dtl");
                DynamicObject newPolicyDtlDtlRowNew = newPolicyDtlDtl.addNew();
                for (String field : rcPolicyDtlDtlSet) {
                    newPolicyDtlDtlRowNew.set(field,policyDtlDtlRow.get(field));
                }
            }
            row.set("rm_row_enable",true);
        }
        //进货上游
        DynamicObjectCollection rmPurUpEntry = rmRcAgreementApply.getDynamicObjectCollection("rm_pur_up_entry");
        DynamicObjectCollection newRmPurUpEntry = newAgreement.getDynamicObjectCollection("rm_pur_up_entry");
        EntityType purUpEntry = allEntities.get("rm_pur_up_entry");
        Set<String> purUpEntrySet = purUpEntry.getFields().keySet();
        for (DynamicObject row : rmPurUpEntry) {
            DynamicObject rowNew = newRmPurUpEntry.addNew();
            for (String field : purUpEntrySet) {
                rowNew.set(field,row.get(field));
            }
        }
        //物料黑名单
        DynamicObjectCollection rmMaterialBlkEntry = rmRcAgreementApply.getDynamicObjectCollection("rm_material_blk_entry");
        DynamicObjectCollection newRmMaterialBlkEntry = newAgreement.getDynamicObjectCollection("rm_material_blk_entry");
        EntityType materialBlkEntry = allEntities.get("rm_material_blk_entry");
        Set<String> materialBlkEntrySet = materialBlkEntry.getFields().keySet();
        for (DynamicObject row : rmMaterialBlkEntry) {
            DynamicObject rowNew = newRmMaterialBlkEntry.addNew();
            for (String field : materialBlkEntrySet) {
                rowNew.set(field,row.get(field));
            }
        }


        SaveServiceHelper.save(new DynamicObject[]{newAgreement});
        SaveServiceHelper.save(new DynamicObject[]{rmRcAgreementApply});
    }

    private static void changeAgreement(DynamicObject rmRcAgreementApply){
        String agmNumber = rmRcAgreementApply.getString("rm_agm_number");
        QFilter qFilter = new QFilter("rm_agm_number", QCP.equals, agmNumber);
        DynamicObject rmRcAgreement = BusinessDataServiceHelper.loadSingle("rm_rc_agreement",qFilter.toArray());
        //单据头
        MainEntityType billType = RMEntityHelper.getEntityType("rm_rc_agreement_apply");
        Map<String, EntityType> allEntities = billType.getAllEntities();
        EntityType entityType = allEntities.get("rm_rc_agreement_apply");
        Set<String> rmRcAgreementApplySet = entityType.getFields().keySet();
        for (String field : rmRcAgreementApplySet) {
            rmRcAgreement.set(field, rmRcAgreementApply.get(field));
        }

        //物料明细
        DynamicObjectCollection rmRcPolicyrecordDtl = rmRcAgreementApply.getDynamicObjectCollection("rm_rc_policyrecord_dtl");
        DynamicObjectCollection newRcPolicyrecordDtl = rmRcAgreement.getDynamicObjectCollection("rm_rc_policyrecord_dtl");
        EntityType policyrecordDtl = allEntities.get("rm_rc_policyrecord_dtl");
        Set<String> policyrecordDtlSet = policyrecordDtl.getFields().keySet();
        //子单据体
        EntityType rcPolicyDtlDtl = allEntities.get("rm_rc_policy_dtl_dtl");
        Set<String> rcPolicyDtlDtlSet = rcPolicyDtlDtl.getFields().keySet();
        for (DynamicObject row : rmRcPolicyrecordDtl) {
            boolean rmRowEnable = row.getBoolean("rm_row_enable");
            if (rmRowEnable) {
                continue;
            }
            DynamicObject rowNew = newRcPolicyrecordDtl.addNew();
            for (String field : policyrecordDtlSet) {
                rowNew.set(field,row.get(field));
            }
            DynamicObjectCollection policyDtlDtl = row.getDynamicObjectCollection("rm_rc_policy_dtl_dtl");
            for (DynamicObject policyDtlDtlRow : policyDtlDtl) {
                DynamicObjectCollection newPolicyDtlDtl = rowNew.getDynamicObjectCollection("rm_rc_policy_dtl_dtl");
                DynamicObject newPolicyDtlDtlRowNew = newPolicyDtlDtl.addNew();
                for (String field : rcPolicyDtlDtlSet) {
                    newPolicyDtlDtlRowNew.set(field,policyDtlDtlRow.get(field));
                }
            }
            row.set("rm_row_enable",true);
        }
        SaveServiceHelper.save(new DynamicObject[]{rmRcAgreement});
        SaveServiceHelper.save(new DynamicObject[]{rmRcAgreementApply});
    }
}
