package yrpg.gmscm.rc.rcd.agreement.operator;

import cn.romens.cloud.xdepot.algo.RMAlgoQuery;
import com.alibaba.fastjson.JSONArray;
import kd.bos.algo.DataSet;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.AddValidatorsEventArgs;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import yrpg.gmscm.rc.rcd.tools.GetFieldsHelper;


import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * @author zhangjiawei
 * &#064;date  2024/4/26 9:43
 */
public class AgmApplyIfRepetitionSubmitOpPlugin extends AbstractOperationServicePlugIn {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        List<String> fieldKeys = e.getFieldKeys();
        List<String> costApplyFields = GetFieldsHelper.getAllFieldsList("rm_rcd_settle_ask");
        fieldKeys.addAll(costApplyFields);
        fieldKeys.add("rm_rc_policyrecord_dtl.seq");
    }
    @Override
    public void onAddValidators(AddValidatorsEventArgs e) {
        e.addValidator(new validation()); //注册校验器
        validators = e.getValidators();
    }

    public List<AbstractValidator> validators = null;

    public static class validation extends AbstractValidator {

        @Override
        public void validate() {
//todo
            for (ExtendedDataEntity dataEntity : this.dataEntities) {
                DynamicObject billData = dataEntity.getDataEntity();
                DynamicObjectCollection policyRecordDtl = billData.getDynamicObjectCollection("rm_rc_policyrecord_dtl");
                //销售组织
                Object rmSaleorg = billData.getDynamicObject("rm_saleorg").getPkValue();
                //办事处
                Object rmOffice = billData.getDynamicObject("rm_office").getPkValue();
                //客户维度
                String rmCusLatitude = billData.getString("rm_cus_latitude");
                //物料维度
                String rmMaterialLatitude = billData.getString("rm_material_latitude");
                List<QFilter> qFilters = new ArrayList<>();
                qFilters.add(new QFilter("rm_saleorg",QCP.equals,rmSaleorg));
                qFilters.add(new QFilter("rm_office",QCP.equals,rmOffice));
                qFilters.add(new QFilter("rm_cus_latitude",QCP.equals,rmCusLatitude));
                qFilters.add(new QFilter("rm_material_latitude",QCP.equals,rmMaterialLatitude));
                StringBuilder queryField = new StringBuilder("rm_rc_policyrecord_dtl.rm_date_begin,rm_rc_policyrecord_dtl.rm_date_end,") ;
                switch (rmCusLatitude){
                    case "A":
                        Object rmClient = billData.getDynamicObject("rm_client").getPkValue();
                        qFilters.add(new QFilter("rm_client",QCP.equals,rmClient));
                        break;
                    case "B":
                        Object rmClientGroup = billData.getDynamicObject("rm_client_group").getPkValue();
                        qFilters.add(new QFilter("rm_client_group",QCP.equals,rmClientGroup));
                        break;
                    case "D":
                        break;
                    default:
                        break;
                }
                switch (rmCusLatitude){
                    case "A":
                        queryField.append("rm_rc_policyrecord_dtl.rm_material as rm_material,");
                        break;
                    case "B":
                        queryField.append("rm_rc_policyrecord_dtl.rm_material_group as rm_material_group,");
                        break;
                    case "C":
                        queryField.append("rm_rc_policyrecord_dtl.rm_rcd_material_type as rm_rcd_material_type,");
                        break;
                    default:
                        break;
                }
                queryField.append("rm_rc_policyrecord_dtl.rm_agreement_begin,rm_rc_policyrecord_dtl.rm_agreement_end");
                DataSet dataSet = RMAlgoQuery.queryDataSet("rm_rc_agreement_apply",
                        queryField.toString(),
                        qFilters.toArray(new QFilter[0]),
                        null);
                for (DynamicObject row : policyRecordDtl) {
                    DataSet filter;
                    switch (rmCusLatitude){
                        case "A":
                            Object material = row.getDynamicObject("rm_material").getPkValue();
                            filter= dataSet.filter("rm_material =Long(" + material + ")");
                            break;
                        case "B":
                            queryField.append("rm_rc_policyrecord_dtl.rm_material_group,");
                            break;
                        case "C":
                            queryField.append("rm_rc_policyrecord_dtl.rm_rcd_material_type,");
                            break;
                        default:
                            break;
                    }
                }


            }
        }
    }

}
