package yrpg.gmscm.rc.rcd.apply.operator;

import cn.romens.cloud.xdepot.algo.RMAlgoQuery;
import kd.bos.algo.DataSet;
import kd.bos.algo.Row;
import kd.bos.db.DB;
import kd.bos.db.tx.TX;
import kd.bos.db.tx.TXHandle;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import yrpg.gmscm.rc.rcd.core.DBRoute;

import java.util.ArrayList;
import java.util.List;

/**
 * @author zhangjiawei
 * @date 2023/8/14 9:33
 * 提交撤销功能
 */
public class RcApplySubmitUndoOpPlugin extends AbstractOperationServicePlugIn {
    @Override
    //撤销申请记录
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        List<Object> successPkIds = getOperationResult().getSuccessPkIds();
        DataSet rmRcdSettleAsk = RMAlgoQuery.queryDataSet("rm_rcd_settle_ask", "id,entryentity.id as entry", new QFilter("id", QCP.in, successPkIds).toArray(), null);
        List<Object[]> deleteApplyLog = new ArrayList<>();
        for (Row row : rmRcdSettleAsk) {
            Object o = row.get("entry");
            deleteApplyLog.add(new Object[]{o});
        }
        TXHandle tx = TX.required();
        try {
            if (!deleteApplyLog.isEmpty()) {
                DB.executeBatch(
                        DBRoute.rcDbRoute(),
                        "DELETE" +
                                " FROM rm_rcd_rc_result_record " +
                                " where frm_src_bill_rowid =? ", deleteApplyLog);
            }
            tx.commit();
        }catch (Exception exception){
            tx.markRollback();
        }finally {
            tx.close();
        }

    }
}
