package yrpg.gmscm.rc.rcd.tools;

import java.util.Calendar;
import java.util.Date;

public class DateCalibrationHelper {

    /**
     * 结束日期校准，增加一天
     * @param date
     * @return 增加一天后的结束日期
     */
    public static Date resetEndDate(Date date){
        if(date==null) {
            return date;
        }
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        instance.add(Calendar.DATE,1);
        Date time = instance.getTime();
        return time;
    }


    /**
     * 返回当前日期 00:00:00时间
     * @return
     */
    public static Date getTodayBegin(){
        Calendar calendar = Calendar.getInstance();
        calendar.set(Calendar.SECOND, 0);
        calendar.set(Calendar.MINUTE, 0);
        calendar.set(Calendar.HOUR_OF_DAY, 0);
        calendar.set(Calendar.MILLISECOND, 0);
        Date today = calendar.getTime();
        return today;
    }

    /**
     * 时间戳转Date类型日期
     * @param timestamp
     * @return
     */
    public static Date getDateByTimestamp(Long timestamp){
        if(timestamp==0L) {
            return new Date();
        }
        Date date = new Date(timestamp);
        return date;
    }

    /**
     * 日期之间相差天数
     * @param begin
     * @param end
     * @return 相差天数
     */
    public static Long getDatesDiff(Date begin,Date end){
        if(begin==null||end==null) {
            return 0L;
        }
        long starTime=begin.getTime();
        long endTime=end.getTime();
        long num=endTime-starTime;//时间戳相差的毫秒数
        return num / 24 / 60 / 60 / 1000;
    }

    /**
     *
     * @param date
     * @return 返回参数日期减一天
     */
    public static Date getDateBeforeOne(Date date){
        if(date==null) {
            return date;
        }
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        instance.add(Calendar.DATE,-1);
        Date time = instance.getTime();
        return time;
    }

    /**
     *
     * @return 返回当前时间的上一个月第一天00：00:00
     */

    public static Date getLastMonthFirstDay(){
        Date date = new Date();
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        instance.set(Calendar.DATE, 1);// 单独设置日历字段，设置天数
        instance.add(Calendar.DATE,-1);
        instance.set(Calendar.DATE, 1);
        instance.set(Calendar.HOUR_OF_DAY, 0);// 单独设置日历字段，设置小时
        instance.set(Calendar.MINUTE, 0);// 单独设置日历字段，设置分钟
        instance.set(Calendar.SECOND, 0);// 单独设置日历字段，设置秒
        instance.set(Calendar.MILLISECOND, 0);// 单独设置日历字段，设置毫秒
        Date time = instance.getTime();
        return time;
    }
    public static Date getLastMonthFirstDay(Date date){
        if(date==null) {
            return date;
        }
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        instance.set(Calendar.DATE, 1);// 单独设置日历字段，设置天数
        instance.add(Calendar.DATE,-1);
        instance.set(Calendar.DATE, 1);
        instance.set(Calendar.HOUR_OF_DAY, 0);// 单独设置日历字段，设置小时
        instance.set(Calendar.MINUTE, 0);// 单独设置日历字段，设置分钟
        instance.set(Calendar.SECOND, 0);// 单独设置日历字段，设置秒
        instance.set(Calendar.MILLISECOND, 0);// 单独设置日历字段，设置毫秒
        Date time = instance.getTime();
        return time;
    }

    /**
     *
     * @return 返回当前时间的上一个月最后一天00：00:00
     */
    public static Date getLastMonthLastDay(){
        Date thisMonthFirstDay = getThisMonthFirstDay();
        Calendar instance = Calendar.getInstance();
        instance.setTime(thisMonthFirstDay);
        instance.add(Calendar.DATE,-1);
        Date time = instance.getTime();
        return time;
    }
    public static Date getLastMonthLastDay(Date date){
        if(date==null) {
            return date;
        }
        Date thisMonthFirstDay = getThisMonthFirstDay(date);
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        instance.setTime(thisMonthFirstDay);
        instance.add(Calendar.DATE,-1);
        Date time = instance.getTime();
        return time;
    }
    /**
     *
     * @return 返回当前月份的第一天00:00:00
     */
    public static Date getThisMonthFirstDay(){
        Date date = new Date();
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        instance.set(Calendar.DATE, 1);// 单独设置日历字段，设置天数
        instance.set(Calendar.HOUR_OF_DAY, 0);// 单独设置日历字段，设置小时
        instance.set(Calendar.MINUTE, 0);// 单独设置日历字段，设置分钟
        instance.set(Calendar.SECOND, 0);// 单独设置日历字段，设置秒
        instance.set(Calendar.MILLISECOND, 0);// 单独设置日历字段，设置毫秒
        Date time = instance.getTime();
        return time;
    }
    public static Date getThisMonthFirstDay(Date date){
        if(date==null) {
            return date;
        }
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        instance.set(Calendar.DATE, 1);// 单独设置日历字段，设置天数
        instance.set(Calendar.HOUR_OF_DAY, 0);// 单独设置日历字段，设置小时
        instance.set(Calendar.MINUTE, 0);// 单独设置日历字段，设置分钟
        instance.set(Calendar.SECOND, 0);// 单独设置日历字段，设置秒
        instance.set(Calendar.MILLISECOND, 0);// 单独设置日历字段，设置毫秒
        Date time = instance.getTime();
        return time;
    }

    /**
     *
     * @return 返回当前月份的最后一天23:59:59
     */
    public static Date getThisMonthEndDay(){
        Date date = new Date();
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        instance.add(Calendar.MONTH,1);
        instance.set(Calendar.DATE,1);
        instance.add(Calendar.DATE,-1);
        Date time = instance.getTime();
        time = getDateEnd(time);
        return time;
    }
    public static Date getThisMonthEndDay(Date date){
        if(date==null) {
            return date;
        }
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        instance.add(Calendar.MONTH,1);
        instance.set(Calendar.DATE,1);
        instance.add(Calendar.DATE,-1);
        Date time = instance.getTime();
        time = getDateEnd(time);
        return time;
    }

    /**
     *
     * @param date
     * @return 获取当前参数的00:00:00
     */
    public static Date getDateBegin(Date date){
        if(date==null) {
            return date;
        }
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        instance.set(Calendar.HOUR_OF_DAY, 0);// 单独设置日历字段，设置小时
        instance.set(Calendar.MINUTE, 0);// 单独设置日历字段，设置分钟
        instance.set(Calendar.SECOND, 0);// 单独设置日历字段，设置秒
        instance.set(Calendar.MILLISECOND, 0);// 单独设置日历字段，设置毫秒
        Date time = instance.getTime();
        return time;
    }

    /**
     *
     * @param date
     * @return 获取当前参数的23:59:59.999
     */
    public static Date getDateEnd(Date date){
        if(date==null) {
            return date;
        }
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        instance.set(Calendar.HOUR_OF_DAY, 23);// 单独设置日历字段，设置小时
        instance.set(Calendar.MINUTE, 59);// 单独设置日历字段，设置分钟
        instance.set(Calendar.SECOND, 59);// 单独设置日历字段，设置秒
        instance.set(Calendar.MILLISECOND, 999);// 单独设置日历字段，设置毫秒
        Date time = instance.getTime();
        return time;
    }

    /**
     * 判断日期是几号，是否和入参相同
     * @param day
     * @return
     */
    public static Boolean checkDateByDay(int day){
        Calendar instance = Calendar.getInstance();
        int i = instance.get(Calendar.DATE);
        return i == day;
    }
    public static Boolean checkDateByDay(Date date,int day){
        if(date==null) {
            return false;
        }
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        int i = instance.get(Calendar.DATE);
        return i == day;
    }

    /**
     * 清除毫秒
     * @param date
     * @return
     */
    public static Date clearMillisecond(Date date){
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        instance.set(Calendar.MILLISECOND, 000);// 单独设置日历字段，设置毫秒
        Date time = instance.getTime();
        return time;
    }

    /**
     *添加几天
     * @param date
     * @param days
     * @return
     */

    public static  Date addDays(Date date, int days){
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        instance.add(Calendar.DATE,days);
        Date time = instance.getTime();
        return time;
    }

    public static  Date addDays(int days){
        Calendar instance = Calendar.getInstance();
        instance.add(Calendar.DATE,days);
        Date time = instance.getTime();
        return time;
    }

    public static Date thisYearFirstDay(){
        Calendar instance = Calendar.getInstance();
        instance.set(Calendar.MONTH,0);
        Date time = instance.getTime();
        Date thisMonthFirstDay = getThisMonthFirstDay(time);
        return thisMonthFirstDay;
    }

    public static Date thisYearFirstDay(Date date){
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        instance.set(Calendar.MONTH,0);
        Date time = instance.getTime();
        Date thisMonthFirstDay = getThisMonthFirstDay(time);
        return thisMonthFirstDay;
    }
    public static Date thisYearLastDay(){
        Calendar instance = Calendar.getInstance();
        instance.set(Calendar.MONTH,11);
        Date time = instance.getTime();
        Date thisMonthFirstDay = getThisMonthEndDay(time);
        return thisMonthFirstDay;
    }
    public static Date thisYearLastDay(Date date){
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        instance.set(Calendar.MONTH,11);
        Date time = instance.getTime();
        Date thisMonthFirstDay = getThisMonthEndDay(time);
        return thisMonthFirstDay;
    }
    public static int getYear(Date date){
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        int i = instance.get(Calendar.YEAR);
        return i;
    }
    public static int getMonth(Date date){
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        int i = instance.get(Calendar.MONTH);
        return i+1;
    }
    public static int getDay(Date date){
        Calendar instance = Calendar.getInstance();
        instance.setTime(date);
        int i = instance.get(Calendar.DATE);
        return i;
    }

}
