package yrpg.slm.rc.plugin.operate;

import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.bos.servicehelper.user.UserServiceHelper;

import kd.sdk.plugin.Plugin;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 换票操作
 */
public class RcdSettleChangeInvoiceinfoOpPlugin extends AbstractOperationServicePlugIn implements Plugin {

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        e.getFieldKeys().add("yrpg_entryentity");
        e.getFieldKeys().add("billno");
        e.getFieldKeys().add("rm_ticket_business");
    }

    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        super.beforeExecuteOperationTransaction(e);
        List<DynamicObject> changeBillList=new ArrayList<>();
        for(DynamicObject bill:e.getDataEntities()){
            //获取发票记录
            DynamicObjectCollection invoiceinfoList= bill.getDynamicObjectCollection("yrpg_entryentity");

            for(DynamicObject invoiceinfo:invoiceinfoList){
                //new一个保存换票记录的单据实体
                DynamicObject changeBill = BusinessDataServiceHelper.newDynamicObject("yrpg_change_invo_record");
                //创建人
                changeBill.set("creator",UserServiceHelper.getCurrentUserId());
                //单据状态
                changeBill.set("billstatus","C");
                //返利兑付申请编号
                changeBill.set("yrpg_settle_no",bill.getString("billno"));
                //红冲商业
                changeBill.set("yrpg_business",bill.getDynamicObject("rm_ticket_business"));
                //发票号
                changeBill.set("yrpg_invoice_no",invoiceinfo.getString("yrpg_invoice_num"));
                //单据日期
                changeBill.set("yrpg_date",new Date());
                //换票记录单据体
                DynamicObjectCollection invoiceList=changeBill.getDynamicObjectCollection("yrpg_entryentity");

                //原发票记录
                DynamicObject rowNew = invoiceList.addNew();
                rowNew.set("yrpg_invoice_num",invoiceinfo.getString("yrpg_invoice_num"));   //发票号
                rowNew.set("yrpg_invo_date",invoiceinfo.getDate("yrpg_invoice_date"));   //发票日期
                rowNew.set("yrpg_change_type","1");   //换票类型
                rowNew.set("yrpg_customer",invoiceinfo.getDynamicObject("yrpg_customer"));   //客户
                rowNew.set("yrpg_material",invoiceinfo.getDynamicObject("yrpg_material"));   //产品
                rowNew.set("yrpg_qty",invoiceinfo.getInt("yrpg_qty"));   //数量
                rowNew.set("yrpg_price",invoiceinfo.getBigDecimal("yrpg_price"));   //单价
                rowNew.set("yrpg_invoice_amount",invoiceinfo.getBigDecimal("yrpg_invoice_amount"));   //发票金额
                rowNew.set("yrpg_sourceno",bill.getString("billno"));   //来源单据编号
                rowNew.set("yrpg_sourceid",bill.getPkValue());   //来源单据ID
                rowNew.set("yrpg_source_rowid",invoiceinfo.getPkValue());   //来源单据行ID
                rowNew.set("yrpg_code_billno",invoiceinfo.getString("yrpg_sourcebillno"));   //核心单据编号
                rowNew.set("yrpg_code_billid",invoiceinfo.getInt("yrpg_yrpg_sourcebillid"));   //核心单据ID

                //新红票记录
                DynamicObject rowNew2 = invoiceList.addNew();
                rowNew2.set("yrpg_invoice_num",invoiceinfo.getString("yrpg_invoice_num"));   //发票号
                rowNew2.set("yrpg_invo_date",invoiceinfo.getDate("yrpg_invoice_date"));   //发票日期
                rowNew2.set("yrpg_change_type","2");   //换票类型
                rowNew2.set("yrpg_customer",invoiceinfo.getDynamicObject("yrpg_customer"));   //客户
                rowNew2.set("yrpg_material",invoiceinfo.getDynamicObject("yrpg_material"));   //产品
                rowNew2.set("yrpg_qty",invoiceinfo.getInt("yrpg_qty"));   //数量
                rowNew2.set("yrpg_price",invoiceinfo.getBigDecimal("yrpg_price").multiply(new BigDecimal(-1)));   //单价
                rowNew2.set("yrpg_invoice_amount",invoiceinfo.getBigDecimal("yrpg_invoice_amount").multiply(new BigDecimal(-1)));   //发票金额
                rowNew2.set("yrpg_sourceno",bill.getString("billno"));   //来源单据编号
                rowNew2.set("yrpg_sourceid",bill.getPkValue());   //来源单据ID
                rowNew2.set("yrpg_source_rowid",invoiceinfo.getPkValue());   //来源单据行ID
                rowNew2.set("yrpg_code_billno",invoiceinfo.getString("yrpg_sourcebillno"));   //核心单据编号
                rowNew2.set("yrpg_code_billid",invoiceinfo.getInt("yrpg_yrpg_sourcebillid"));   //核心单据ID

                //新蓝票记录
                DynamicObject rowNew3 = invoiceList.addNew();
                rowNew3.set("yrpg_invoice_num",invoiceinfo.getString("yrpg_invoice_num"));   //发票号
                rowNew3.set("yrpg_invo_date",invoiceinfo.getDate("yrpg_invoice_date"));   //发票日期
                rowNew3.set("yrpg_change_type","3");   //换票类型
                rowNew3.set("yrpg_customer",invoiceinfo.getDynamicObject("yrpg_customer"));   //客户
                rowNew3.set("yrpg_material",invoiceinfo.getDynamicObject("yrpg_material"));   //产品
                rowNew3.set("yrpg_qty",invoiceinfo.getInt("yrpg_qty"));   //数量
                rowNew3.set("yrpg_price",invoiceinfo.getBigDecimal("yrpg_last_offset_price"));   //单价
                rowNew3.set("yrpg_invoice_amount",invoiceinfo.getBigDecimal("yrpg_last_amount"));   //发票金额
                rowNew3.set("yrpg_sourceno",bill.getString("billno"));   //来源单据编号
                rowNew3.set("yrpg_sourceid",bill.getPkValue());   //来源单据ID
                rowNew3.set("yrpg_source_rowid",invoiceinfo.getPkValue());   //来源单据行ID
                rowNew3.set("yrpg_code_billno",invoiceinfo.getString("yrpg_sourcebillno"));   //核心单据编号
                rowNew3.set("yrpg_code_billid",invoiceinfo.getInt("yrpg_yrpg_sourcebillid"));   //核心单据ID

                changeBillList.add(changeBill);
            }
        }
        SaveServiceHelper.saveOperate("yrpg_change_invo_record",changeBillList.toArray(new DynamicObject[0]), OperateOption.create());
    }
}